#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <mysql/mysql.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <signal.h>
#include <errno.h>

#define BUFFSIZE 8
#define DB_SERV "localhost"
#define DB_USER "root"
#define DB_PASS "kafadar"
#define DB_NAME "HSBS_WSN"
#define MAX_HUM 95
#define MIN_HUM 2.0
#define MAX_TEM 45.0
#define MIN_TEM 5.0

#define BAUDRATE 9600
#define MODEMDEVICE "/dev/ttyACM0"
#define _POSIX_SOURCE 1






MYSQL_RES *res;

MYSQL_ROW row;

struct SensorTable

{
	char *id;
	char *ip;
	char *location;
	int pid;
};

struct SensorTable *SensorInfo = NULL;
unsigned int num_fields;
unsigned int num_sensors;
unsigned long *field_length = NULL;
char quitt;
char val[200];
int fd, c, resser;
struct termios oldtio, newtio;


struct values{
	double val;
	int type;
};


void init_tty(char* device, int baudrate){
    int speed;
    switch(baudrate){ 
		case	600:	speed = B600; break;
		case	1200:	speed = B1200; break;
		case	2400:	speed = B2400; break;
		case	4800:	speed = B4800; break;
		case	9600:	speed = B9600; break;
		case	19200:	speed = B19200; break;
		case	38400:	speed = B38400; break;
		case	57600:	speed = B57600; break;
		case	115200:	speed = B115200; break;
		case	230400:	speed = B230400; break;
		default:    printf("Sorry, this baudrate is not supported.\n"); exit(-1);
	    }
    
    
    /*
     Open modem device for reading and writing and not as controlling tty
     because we don't want to get killed if linenoise sends CTRL-C.
     */
    
    
    
    fd = open(device, O_RDWR | O_NOCTTY);
    if (fd <0) 
        {perror(device); exit(-1); }
    else 
        {fcntl(fd, F_SETFL, 0); }

    
    printf("Reading from %s (%d baud)\n", device, baudrate);
    
    tcgetattr(fd, &oldtio); /* save current serial port settings */
    bzero(&newtio, sizeof(newtio)); /* clear struct for new port settings */
    
    /*
     BAUDRATE: Set bps rate. You could also use cfsetispeed and cfsetospeed.
     CRTSCTS : output hardware flow control (only used if the cable has
     all necessary lines. See sect. 7 of Serial-HOWTO)
     CS8     : 8n1 (8bit,no parity,1 stopbit)
     CLOCAL  : local connection, no modem contol
     CREAD   : enable receiving characters
     */
    //newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
    newtio.c_cflag |= (CLOCAL | CREAD);

    newtio.c_cflag &= ~PARENB;
    newtio.c_cflag &= ~CSTOPB;
    newtio.c_cflag &= ~CSIZE;
    newtio.c_cflag |= CS8;


    cfsetispeed(&newtio, speed);
    cfsetospeed(&newtio, speed);
    /*
     IGNPAR  : ignore bytes with parity errors
     ICRNL   : map CR to NL (otherwise a CR input on the other computer
     will not terminate input)
     otherwise make device raw (no other input processing)
     */
    newtio.c_iflag = IGNPAR | ICRNL;
    
    /*
     Raw output.
     */
    newtio.c_oflag = 0;
    
    /*
     ICANON  : enable canonical input
     disable all echo functionality, and don't send signals to calling program
     */
    newtio.c_lflag = ICANON;
    
    /*
     initialize all control characters
     default values can be found in /usr/include/termios.h, and are given
     in the comments, but we don't need them here
     */
    newtio.c_cc[VINTR]    = 0;     /* Ctrl-c */
    newtio.c_cc[VQUIT]    = 0;     /* Ctrl-\ */
    newtio.c_cc[VERASE]   = 0;     /* del */
    newtio.c_cc[VKILL]    = 0;     /* @ */
    newtio.c_cc[VEOF]     = 1;     /* Ctrl-d */
    newtio.c_cc[VTIME]    = 0;     /* inter-character timer unused */
    newtio.c_cc[VMIN]     = 3;     /* blocking read until 1 character arrives */
    newtio.c_cc[VSWTC]    = 0;     /* '\0' */
    newtio.c_cc[VSTART]   = 0;     /* Ctrl-q */
    newtio.c_cc[VSTOP]    = 0;     /* Ctrl-s */
    newtio.c_cc[VSUSP]    = 0;     /* Ctrl-z */
    newtio.c_cc[VEOL]     = 0;     /* '\0' */
    newtio.c_cc[VREPRINT] = 0;     /* Ctrl-r */
    newtio.c_cc[VDISCARD] = 0;     /* Ctrl-u */
    newtio.c_cc[VWERASE]  = 0;     /* Ctrl-w */
    newtio.c_cc[VLNEXT]   = 0;     /* Ctrl-v */
    newtio.c_cc[VEOL2]    = 0;     /* '\0' */
    
    /*
     now clean the modem line and activate the settings for the port
     */
    tcflush(fd, TCIFLUSH);
    tcsetattr(fd, TCSANOW, &newtio);
    
}


void recordString(char* value, MYSQL *mysql)
{
	int i;
	struct values measure;
	char query[500] ;
    char *sensID;
    float maxTem,maxHum,minTem,minHum;
    static float preHum =30;
    static float preTem = 10;
    static int sentLast = 0;
	query[0]=0;
	
	for(i = 0; i < num_sensors; i++)
	{
	   if(getpid() == SensorInfo[i].pid)
		{   char myQry[200]="SELECT MaxTem, MaxHum, MinTem, MinHum FROM Sensors WHERE SensorID = ";
            sensID = strdup(SensorInfo[i].id);
            strcat(myQry,sensID);
            strcat(myQry," ;");
            mysql_query(mysql,myQry);
            res = mysql_store_result(mysql);
            row = mysql_fetch_row(res);
            maxTem = atof (row[0]);
            maxHum = atof (row[1]);
            minTem = atof (row[2]);
            minHum = atof (row[3]);
            /*printf("ID:%s H:%f h:%f T:%f t:%f\n",sensID,maxHum,minHum,maxTem,minTem);*/
            free(res);

        }
    }

	if(value[0] == 'T' || value[0] == 't')
    {
		measure.type = 1;
        /*
		for(i = 0; i < num_sensors; i++)
		{
			if(getpid() == SensorInfo[i].pid)
			{
				strcat(query, "INSERT INTO Temperature VALUES (");
				strcat(query, SensorInfo[i].id);
				strcat(query, ",NOW(),");
			}				
		}*/
		strcat(query, "INSERT INTO Temperature VALUES (");
		strcat(query, sensID);
		strcat(query, ",NOW(),");


		strcat(query, value + 2);
		strcat(query,");");
		measure.val = atof(value+2);
        

        /* Alert issue occured opening cell phone device as modem ttyACM0, creating the message to send and writing on it */	
		if (((measure.val > maxTem && preTem > maxTem) || (measure.val < minTem && preTem < minTem)) && !sentLast)
		{   
            char smsheader[100] = "AT+CMGS=\"";
            char smstext[500] = "Temperature Violation at Sensor "; 
            char nbuf[25];
            char *sensLocation;
            char *userPhone;
            char myQry[100] = "SELECT Location FROM Sensors WHERE SensorID = ";
            strcat(smstext,sensID);
            strcat(myQry,sensID);
            strcat(myQry,";");
            
            /* Gathering the Location information from Sensors Table */
            mysql_query(mysql,myQry);

            res = mysql_use_result(mysql);
            row = mysql_fetch_row(res);
            sensLocation = strdup(row[0]);


            /* Gather the Phone number of the user. */

            mysql_query(mysql,"SELECT Phone FROM Users;");
            res = mysql_store_result(mysql);
            row = mysql_fetch_row(res);
            userPhone = strdup(row[0]);

            /* SMS Text */
            strcat(smstext,"\nTemperature Value: ");
            sprintf(nbuf,"%f",measure.val);
            strcat(smstext,nbuf);
            strcat(smstext,"\nLocation: ");
            strcat(smstext,sensLocation);
            strcat(smstext,"\32\r\n");
			printf("%s\n", smstext);
            init_tty(MODEMDEVICE,BAUDRATE);

            /* Writing to Modem Device in AT-Command format for Nokia 6230i */
            write(fd,"AT\r",strlen("AT\r"));
            write(fd,"AT+CMGF=1\n\r",strlen("AT+CMGF=1\r\n"));
            strcat(smsheader,userPhone);
            strcat(smsheader,"\"\r\n");
            write(fd,smsheader,strlen(smsheader));

            write(fd,smstext,strlen(smstext));
            /*restore old settings*/
            tcsetattr(fd, TCSANOW, &oldtio);
            /* close port */
            close(fd);
            sentLast=20;


		}

		mysql_query(mysql,query);
        preTem = measure.val;
        if (sentLast>0)
            sentLast--;

	}
	else if(value[0] == 'H' || value[0] == 'h')
	{
		measure.type = 2;
		for(i = 0; i < num_sensors; i++)
		{
			if(getpid() == SensorInfo[i].pid)
			{
				strcat(query, "INSERT INTO Humidity VALUES (");
				strcat(query, SensorInfo[i].id);
				strcat(query, ",NOW(),");
			}				
		}
		strcat(query, value+2);
		strcat(query,");");

		measure.val = atof(value+2);
	    /* Alert issue occured opening cell phone device as modem ttyACM0, creating the message to send and writing on it */	
		if (((measure.val > maxHum && preHum > maxHum) || (measure.val < minHum && preHum < minHum)) && !sentLast)
		{   
            char smsheader[100] = "AT+CMGS=\"";
            char smstext[500] = "Humudity Violation at Sensor "; 
            char nbuf[25];
            char *sensLocation;
            char *userPhone;
            char myQry[100] = "SELECT Location FROM Sensors WHERE SensorID = ";
            strcat(smstext,sensID);
            strcat(myQry,sensID);
            strcat(myQry,";");
            
            /* Gathering the Location information from Sensors Table */
            mysql_query(mysql,myQry);
            res = mysql_store_result(mysql);
            row = mysql_fetch_row(res);
            sensLocation = strdup(row[0]);

            /* Gather the Phone number of the user. */
            mysql_query(mysql,"SELECT Phone FROM Users;");
            res = mysql_store_result(mysql);
            row = mysql_fetch_row(res);
            userPhone = strdup(row[0]);

            /* SMS Text */
            strcat(smstext,"\nHumidity Value: ");
            sprintf(nbuf,"%f",measure.val);
            strcat(smstext,nbuf);
            strcat(smstext,"\nLocation: ");
            strcat(smstext,sensLocation);
            strcat(smstext,"\32\r\n");
			printf("%s\n", smstext);
            init_tty(MODEMDEVICE,BAUDRATE);

            /* Writing to Modem Device in AT-Command format for Nokia 6230i */
            write(fd,"AT\r",strlen("AT\r"));
            write(fd,"AT+CMGF=1\n\r",strlen("AT+CMGF=1\r\n"));
            strcat(smsheader,userPhone);
            strcat(smsheader,"\"\r\n");
            write(fd,smsheader,strlen(smsheader));

            write(fd,smstext,strlen(smstext));
            /*restore old settings*/
            tcsetattr(fd, TCSANOW, &oldtio);
            /* close port */
            close(fd);
            sentLast = 20;

		}
		mysql_query(mysql,query);
        preHum = measure.val;
        if (sentLast>0)
            sentLast--;
	}
}

void getIp(MYSQL *mysql)
{
	int i, j;
	if(mysql_query(mysql, "SELECT * FROM Sensors;"))
		printf("Query error\n");
	
	if(!(res = mysql_store_result(mysql)))
		printf("Storing result error\n");
	
	num_fields = mysql_num_fields(res);
	for(i = 0; row = mysql_fetch_row(res); i++)
	{
		field_length = mysql_fetch_lengths(res);
		if((SensorInfo = (struct SensorTable *) realloc(SensorInfo, (i + 1) * sizeof(struct SensorTable))) == NULL)
		{
			printf("Reallocation problem. Terminating the program...\n");
			exit(1);
		}
		for(j = 0; j < num_fields; j++)
		{
			if(j == 0)
			{
				SensorInfo[i].id = malloc(field_length[j] + 1);
				strcpy(SensorInfo[i].id, row[j]);
				SensorInfo[i].id[field_length[j]] = '\0';
				
			}
			else if(j == 1)
			{
				SensorInfo[i].ip = malloc(field_length[j] + 1);
				strcpy(SensorInfo[i].ip, row[j]);
				SensorInfo[i].ip[field_length[j]] = '\0';
			}
			else if(j == 2)
			{
				SensorInfo[i].location = malloc(field_length[j] + 1);
				strcpy(SensorInfo[i].location, row[j]);
				SensorInfo[i].location[field_length[j]] = '\0';
			}
		}
		num_sensors = i + 1;
	}
	mysql_free_result(res);
}

int main(void) 
{
	int sock;
	struct sockaddr_in echoserver;
	char buffer[BUFFSIZE];
	unsigned int echolen;
	int received = 0;
	int mainPID, lastPID;
	MYSQL mysql;
	int i, j, k;
	int temp_pid;
	int startup = 1;

    if (!mysql_init(&mysql))
	{
		fprintf(stderr,"Failed to initate MySQL\n");
		exit (1);
	}
		
	if (!mysql_real_connect(&mysql,DB_SERV, DB_USER, DB_PASS, DB_NAME, 0, NULL, 0))
	{
		fprintf(stderr,"Unable to connect MySQL Server\n");
		exit (1);
	}
	
	getIp(&mysql);
	mainPID = getpid();
	
    if(mainPID == getpid())
	{
		for (i = 0; i <= num_sensors; i++)
		{
			if (mainPID == getpid())
			{
				temp_pid = fork();
				if (0 == temp_pid)
				{
					if(i != num_sensors)
						SensorInfo[i].pid = getpid();
					else
						lastPID = getpid();
				}
				else
				{
					if(i != num_sensors)
						SensorInfo[i].pid = temp_pid;
					else
						lastPID = temp_pid;
				}
			}
		}
	}
	while((mainPID != getpid()) && (lastPID != getpid()))
	{
		if (!mysql_init(&mysql))
		{
// 			fprintf(stderr,"Failed to initate MySQL\n");
			exit (1);
		}
		
		if (!mysql_real_connect(&mysql,DB_SERV, DB_USER, DB_PASS, DB_NAME, 0, NULL, 0))
		{
// 			fprintf(stderr,"Unable to connect MySQL Server\n");
			exit (1);
		}
		/* Create the TCP socket */
		if ((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) 
		{
			fprintf(stdout, "Failed to create socket\n");
		}
		/* Construct the server sockaddr_in structure */
		memset(&echoserver, 0, sizeof(echoserver));       /* Clear struct */
		echoserver.sin_family = AF_INET;                  /* Internet/IP */
		for(i = 0; i < num_sensors; i++)
		{
			if(getpid() == SensorInfo[i].pid)
			{
				echoserver.sin_addr.s_addr = inet_addr(SensorInfo[i].ip);  /* IP address of 1st */
				echoserver.sin_port = htons(2000);       /* server port */
				/* Establish connection */
				fprintf(stdout, "Trying to establish a connection with HSBS_Sentinel with ID: %s...\n", SensorInfo[i].id);
				if (connect(sock, (struct sockaddr *) &echoserver, sizeof(echoserver)) < 0)
				{
					fprintf(stdout, "Failed to connect with HSBS_Sentinel %s\n", SensorInfo[i].id);
					startup = 2;
					sleep(5);
				}
				else
					fprintf(stdout, "Receiving from: %s\n", SensorInfo[i].id);
			}
		}
		
		while(1)
		{
			
			if(startup == 2)
			{
				for(i = 0; i < num_sensors; i++)
				{
					if(getpid() == SensorInfo[i].pid)
					{
						k = 0;
						while(1)
						{
							fprintf(stdout, "Trying to establish a connection with HSBS_Sentinel with ID: %s...\n", SensorInfo[i].id);
							if (connect(sock, (struct sockaddr *) &echoserver, sizeof(echoserver)) < 0)
							{
								fprintf(stdout, "Failed to connect with HSBS_Sentinel %s\n", SensorInfo[i].id);
								sleep(5);
							}
							else
							{
								fprintf(stdout, "Receiving from: %s\n", SensorInfo[i].id);
								startup = 1;
								break;
							}
						}
					}
				}
			}
			else if(startup == 1)
			{				
				int bytes = 0;
				bytes = read(sock, buffer, BUFFSIZE-1);
				if (bytes == 0)
				{
					sleep(5);			
					close(sock);
					shutdown(sock, SHUT_RDWR);
					if ((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) 
					{
						fprintf(stdout, "Failed to create socket\n");
					}
					memset(&echoserver, 0, sizeof(echoserver));       /* Clear struct */
					echoserver.sin_family = AF_INET;                  /* Internet/IP */
					for(i = 0; i < num_sensors; i++)
					{
						if(getpid() == SensorInfo[i].pid)
						{
							echoserver.sin_addr.s_addr = inet_addr(SensorInfo[i].ip);  /* IP address of 1st */
							echoserver.sin_port = htons(2000);       /* server port */
							/* Establish connection */
							k = 0;
							while(1)
							{
								fprintf(stdout, "Trying to establish a connection with HSBS_Sentinel with ID: %s...\n", SensorInfo[i].id);
								if (connect(sock, (struct sockaddr *) &echoserver, sizeof(echoserver)) < 0)
								{
									fprintf(stdout, "Failed to connect with HSBS_Sentinel %s\n", SensorInfo[i].id);
									sleep(5);
								}
								else
								{
									fprintf(stdout, "Receiving from: %s\n", SensorInfo[i].id);
									break;
								}
							}
						}
					}
				}
				received += bytes;
				buffer[bytes] = '\0';        /* Assure null terminated string */
				for(i = 0; i < num_sensors; i++)
				{
					if(getpid() == SensorInfo[i].pid)
					{
						if(bytes == 7)
						{
							fprintf(stdout, "%s	Received from Sensor %s\n", buffer, SensorInfo[i].id);
							recordString(buffer,&mysql);
						}
					}
				}
			}			
		}
		flush(buffer);
		fprintf(stdout, "\n");
		close(sock);
	}
	if(lastPID == getpid())
	{
		while(1)
		{
			scanf("%c", &quitt);
			if((quitt == 'q') || (quitt == 'Q'))
			exit(1);
		}
	}
	if(mainPID == getpid())
	{   
		waitpid(lastPID, NULL, 0);
		for(i = 0; i < num_sensors; i++)
		{
			kill(SensorInfo[i].pid, SIGKILL);
		}
		kill(lastPID, SIGKILL);
		exit(0);
	}
}
