#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <mysql/mysql.h>

#define BUFFSIZE 32
#define DB_SERV "localhost"
#define DB_USER "root"
#define DB_PASS "kafadar"
#define DB_NAME "HSBS_WSN"
#define MAX_HUM 65.0
#define MIN_HUM 2.0
#define MAX_TEM 35.0
#define MIN_TEM 5.0


void Die(char *mess) { perror(mess); exit(1); }


struct values{

	double val;
	
	int type;

};

void recordString(char* value, MYSQL *mysql)

{
	
	struct values measure;
	char query[500];
        query[0]=0;

	if(value[0] == 'T' || value[0] == 't')
	
	{
	
		measure.type = 1;
		strcat(query,"INSERT INTO Temperature VALUES (1,NOW(),");
        	strcat(query, value+2);
        	strcat(query,");");
        	measure.val = atof(value+2);
        if (measure.val > MAX_TEM || measure.val < MIN_TEM){
            fprintf(stderr,"Alert!! Temperature:");
	    printf("%lf\n", measure.val);
	}


        mysql_query(mysql,query);
		
		
	}
	
	else if(value[0] == 'H' || value[0] == 'h')
		
	{
		
		measure.type = 2;
		
	    strcat(query,"INSERT INTO Humidity VALUES (1,NOW(),");
        strcat(query, value+2);
        strcat(query,");");

		measure.val = atof(value+2);

        if (measure.val > MAX_HUM || measure.val < MIN_HUM){
            fprintf(stderr,"Alert!! Humidity:");
	    printf("%lf\n", measure.val); 	
        }


        mysql_query(mysql,query);


        
		
		//printf(query);
        //printf("\n");
	}
	
	else
		
	{
		fprintf(stderr,"Recieved string is not a valid sensor data!\n");
        	fprintf(stderr,value);
        	fprintf(stderr,"\n");
		
	}

}







int main(void) {
            int sock;
            struct sockaddr_in echoserver;
            char buffer[BUFFSIZE];
            unsigned int echolen;
            int received = 0;
            MYSQL mysql;

            if (!mysql_init(&mysql))
            {
                fprintf(stderr,"\nFailed to initate MySQL");
                exit (1);
            }

            if (!mysql_real_connect(&mysql,DB_SERV, DB_USER, DB_PASS, DB_NAME, 0, NULL, 0)){
                fprintf(stderr,"\nUnable to connect MySQL Server");
                exit (1);
            }




            /* Create the TCP socket */
            if ((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) {
              Die("Failed to create socket");
            }

/* Construct the server sockaddr_in structure */
            memset(&echoserver, 0, sizeof(echoserver));       /* Clear struct */
            echoserver.sin_family = AF_INET;                  /* Internet/IP */
            echoserver.sin_addr.s_addr = inet_addr("192.168.2.254");  /* IP address */
            echoserver.sin_port = htons(atoi("2000"));       /* server port */
            /* Establish connection */
            if (connect(sock,
                        (struct sockaddr *) &echoserver,
                        sizeof(echoserver)) < 0) {
              Die("Failed to connect with server");
            }

/* Send the word to the server
            echolen = strlen(argv[2]);
            if (send(sock, argv[2], echolen, 0) != echolen) {
              Die("Mismatch in number of sent bytes");
            }
*/

/* Receive the word back from the server */
            /*echolen = 5000;*/
            fprintf(stdout, "Receiving from: 192.168.2.254\n");
            /*while (received < echolen) { */
            while(1){
              int bytes = 0;
              if ((bytes = recv(sock, buffer, BUFFSIZE-1, 0)) < 1) {
                Die("Failed to receive bytes from server");
              }
              received += bytes;
              buffer[bytes] = '\0';        /* Assure null terminated string */
              fprintf(stdout, buffer);
              //if (bytes > 2)
                  recordString(buffer,&mysql);
            }
            fprintf(stdout, "\n");
           close(sock);
           exit(0);
          }


